'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
exports.addEventHandler = exports.dispatch = exports.setState = exports.getState = exports.ROOT_DESCRIBE_BLOCK_NAME = undefined;

var _utils = require('./utils');

var _eventHandler = require('./eventHandler');

var _eventHandler2 = _interopRequireDefault(_eventHandler);

var _formatNodeAssertErrors = require('./formatNodeAssertErrors');

var _formatNodeAssertErrors2 = _interopRequireDefault(_formatNodeAssertErrors);

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {default: obj};
}

/**
 * Copyright (c) 2014-present, Facebook, Inc. All rights reserved.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 *  strict-local
 */

const eventHandlers = [
  _eventHandler2.default,
  _formatNodeAssertErrors2.default
];

const ROOT_DESCRIBE_BLOCK_NAME = (exports.ROOT_DESCRIBE_BLOCK_NAME =
  'ROOT_DESCRIBE_BLOCK');
const STATE_SYM = Symbol('JEST_STATE_SYMBOL');

const ROOT_DESCRIBE_BLOCK = (0, _utils.makeDescribe)(ROOT_DESCRIBE_BLOCK_NAME);
const INITIAL_STATE = {
  currentDescribeBlock: ROOT_DESCRIBE_BLOCK,
  currentlyRunningTest: null,
  expand: undefined,
  hasFocusedTests: false, // whether .only has been used on any test/describe
  includeTestLocationInResult: false,
  parentProcess: null,
  rootDescribeBlock: ROOT_DESCRIBE_BLOCK,
  testNamePattern: null,
  testTimeout: 5000,
  unhandledErrors: []
};

global[STATE_SYM] = INITIAL_STATE;

const getState = (exports.getState = () => global[STATE_SYM]);
const setState = (exports.setState = state => (global[STATE_SYM] = state));

const dispatch = (exports.dispatch = event => {
  for (const handler of eventHandlers) {
    handler(event, getState());
  }
});

const addEventHandler = (exports.addEventHandler = handler => {
  eventHandlers.push(handler);
});
